const webpack = require("webpack")
const util = require("../util")
// const ChunkRenamePlugin = require("./chunk-rename-webpack-plugin")
const { webpackConfig, templates } = require("./webpack.config.base")
const userConfig = require('./webpack.config.base').userConfig
const MiniCssExtractPlugin = require('mini-css-extract-plugin')
const VueLoaderPlugin = require('vue-loader/lib/plugin');

module.exports = Object.assign({}, webpackConfig, {
  output: Object.assign({}, webpackConfig.output, {
    // 在生成的文件中添加原来文件的名字,方便调试
    pathinfo: true
  }),
  externals: {
    vue: 'window.fe.vue'
  },
  performance: {
    maxEntrypointSize: 1000000,
    maxAssetSize: 1000000
  },
  module: {
    rules: webpackConfig.module.rules.concat(
      // vue
      {
        test: /\.vue$/,
        loader: 'vue-loader',
        options: {
          preserveWhitespace: false
        }
      },
      // style
      util.stlyeRules(true)
    )
  },
  plugins: [
    new VueLoaderPlugin(),
    new MiniCssExtractPlugin({
      filename: userConfig.chunkhash ? '[name].[chunkhash:' + userConfig.chunkhash + '].css' : '[name].css',
      allChunks: true
    }),
    // new ChunkRenamePlugin(templates)
    // new webpack.DefinePlugin({
    //   'process.env': {
    //     NODE_ENV: '"development"'
    //   }
    // })
  ],
  mode: 'development',
  devtool: '#cheap-module-eval-source-map',
  performance: {
    hints: false
  },
  watch: true
})
